﻿SuperStrict

Import "src/TText.bmx"
Import "src/TTextEffectTypewriter.bmx"
Import "src/TTextEffectScramble.bmx"


AppTitle = "MiniBCC #25 - Texteffekt - Xeres"

' =-=-=-=-=-=-=-=-=-=-=-=-=-=-=
' Config

Global gfx_w:Int = 800
Global gfx_h:Int = 600

Local font:String = "cour" ' Arial, verdana, tahoma, cour
Local size:Int = 22
Local txt:String = "Zwei flinke Boxer jagen die quirlige Eva und ihren Mops durch Sylt. Franz jagt im komplett verwahrlosten Taxi quer durch Bayern. Zwölf Boxkämpfer jagen Viktor quer über den großen Sylter Deich. Vogel Quax zwickt Johnys Pferd Bim."
Local txtWidth:Float = gfx_w *.5

Local effectScramble:TTextEffect = TTextEffectScramble.Create(100, MilliSecs())
Local effectTypewriter:TTextEffect = TTextEffectTypewriter.Create(100, "|")

' =-=-=-=-=-=-=-=-=-=-=-=-=-=-=

Graphics(gfx_w, gfx_h, 0, 60)
AutoMidHandle(True)
SeedRnd MilliSecs()
Local Frametimer:TTimer = TTimer.Create(59)
LoadFont(font, size)
SetColor(0, 0, 0)
SetClsColor(255, 255, 255)
SetBlend(ALPHABLEND)

Local text1:TText = TText.Create(txt, [effectScramble])
Local text2:TText = TText.Create(txt, [effectTypewriter])
Local text3:TText = TText.Create(txt, [effectScramble, effectTypewriter])

Repeat
	Cls

	text1.Draw(10, 10, txtWidth)
	text2.Draw(10, gfx_h *.33, txtWidth)
	text3.Draw(10, gfx_h *.66, txtWidth)

	Flip(0)
	Frametimer.Wait()
	If KeyHit(KEY_ESCAPE) Or AppTerminate() Then End
Forever
End

Function LoadFont(font:String, size:Int = 22)
	Local fallback:String = "Arial"
	Local imageFont:TImageFont = LoadImageFont(getenv_("windir") + "/fonts/" + font + ".ttf", size)
	
	If Not imageFont Then
		imageFont:TImageFont = LoadImageFont(getenv_("windir") + "/fonts/" + fallback + ".ttf", size)
	EndIf
	
	SetImageFont(imageFont)
End Function