SuperStrict

Import "TTextEffect.bmx"

Type TText
	Field txt:String
	Field effects:TTextEffect[]

	Field seed:Int
	Field effectTime:Int = -1
	Field effectLength:Int = 100

	Function Create:TText(_txt:String, effects:TTextEffect[])
		Local o:TText = new TText
			o.txt = _txt
			o.effects = effects
			o.seed = MilliSecs()
		return o
	EndFunction

	Method Draw(x:Float, y:Float, cutoff:Float = -1)

		Local text:String = Self.Effect()

		If cutoff < 0 Then
			DrawText(text, x, y)
			Return
		EndIf

		Local out:String = ""
		Local LineHeight:Float = TextHeight("X")
		Local Line:Int = 0
		Local words:String[] = text.Split(" ")

		For Local i:Int = 0 Until words.Length

			If TextWidth(out) < cutoff Then
				out = out + words[i] + " "
				If TextWidth(out) > cutoff Then
					DrawText(out, x, y + Line * LineHeight)
					out = ""
					Line:+1
				EndIf
			Else
				DrawText(out, x, y + Line * LineHeight)
				out = ""
				Line:+1
			EndIf

		Next
		DrawText(out, x, y + Line * LineHeight)
	End Method

	Method Effect:String()

		Local result:String = txt

		For Local e:TTextEffect = EachIn effects

			If e.hasEnded() Then
				Continue
			EndIf

			result = e.applyEffect(result)

		Next

		Return result

	End Method

EndType
