SuperStrict

Import "TTextEffect.bmx"

Type TTextEffectScramble Extends TTextEffect

	Field charTime:Int
	Field seed:Int

	Function Create:TTextEffectScramble(charTime:Int = 100, seed:Int = -1)
		Local o:TTextEffectScramble = New TTextEffectScramble
			o.charTime = charTime
			o.seed = seed
		Return o
	End Function

	Method applyEffect:String(txt:String)
		Local ms:Int = MilliSecs()
		If effectTimeStart = -1 Then
			effectTimeStart = ms
		EndIf

		Local fullEffectLength:Float = charTime * txt.Length
		Local effectFactor:Float = Float(ms - effectTimeStart) / fullEffectLength

		If effectFactor > 1.0 Then
			done = true
			Return txt
		EndIf

		Local saveSeed:Int = RndSeed()
		SeedRnd(seed)

		Local result:String = ""
		Local charStart:Int = Asc("A"), charEnd:Int = Asc("z")
		For Local i:Int = 0 Until txt.Length
			If txt[i] = 32 Then
				result:+" "
			Else
				result:+Chr(Rand(charStart, charEnd))
			EndIf
		Next


		Local list:Int[] = noDoublettes(txt.Length - 1)
		Local replaceChars:Int = txt.Length * effectFactor
		For Local i:Int = EachIn list
			If replaceChars = 0 Then Exit
			replaceChars:-1
			result = result[..i] + Chr(txt[i]) + result[i + 1..]
		Next


		SeedRnd(saveSeed)
		Return result
	End Method

	Function noDoublettes:Int[] (maximum:Int)
		Local result:Int[maximum]
		For Local i:Int = 0 Until maximum
			Local present:Int = False
			Local r:Int
			Repeat
				present = False
				r:Int = Rand(0, maximum)
				For Local z:Int = 0 Until maximum
					If r = result[z]
						present = True
						Exit
					EndIf
				Next
			Until present = False
			result[i] = r
		Next

		Return result
	End Function

End Type
